<template>
  <div class="weather-report-container">
    <template v-if="!isLoading">
      <div class="rain-effect">
        <RainEffect v-if="isRainy"/>
      </div>
      <CurrentDayReport v-if="currentDayConfig" :currentDay="currentDayConfig"/>
      <div class="week-days-container">
        <div v-for="weekDay in weekDaysConfig" :key="weekDay.iconUrl" class="week-day-report">
          <WeekDayReport :weekDayConfig="weekDay"/>
        </div>
      </div>
    </template>
    <h1 v-if="isLoading">LOADING...</h1>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';

import { useFetch } from '@/lib/useFetch';
import { convertMPStoKMPH, getDirectionFromDegree } from '@/lib/utils/wind';
import { getWeekDay } from '@/lib/utils/date';
import RainEffect from '@/lib/effects/rain-effect/rain-effect.vue';

import { CurrentDay, WeekDay } from './interfaces/weather-report.interface';
import CurrentDayReport from './presentationals/current-day-report/current-day-report.vue';
import WeekDayReport from './presentationals/week-day-report/week-day-report.vue';

export default defineComponent({
  components: { CurrentDayReport, WeekDayReport, RainEffect },
  data() {
    return {
      responseValue: {} as any,
      currentDayConfig: {} as CurrentDay,
      weekDaysConfig: [] as WeekDay[],
      isLoading: false,
      isRainy: false,
    };
  },
  created(): void {
    this.isRainy = false;
    this.isLoading = true;
    this.responseValue = useFetch(
        'https://api.openweathermap.org/data/2.5/onecall?lon=2.159&lat=41.3888&units=metric&appid=9e9e8c58a6f9dcf70432413a59326e2e');
    this.responseValue.fetch().then(() => {
      this.extractCurrentDay();
      this.extractNextFiveDays();
      this.isLoading = this.responseValue.isLoading;
    });
  },
  methods: {
    extractCurrentDay: function (): void {
      if (!this.responseValue?.data?.current) return;
      const icon = this.responseValue.data.current.weather[0]?.icon;
      this.currentDayConfig = {
        highTemp: this.responseValue.data.current.temp,
        humidity: this.responseValue.data.current.humidity,
        uvi: this.responseValue.data.current.uvi,
        wind: `${getDirectionFromDegree(this.responseValue.data.current.wind_deg)} ${convertMPStoKMPH(this.responseValue.data.current.wind_speed)}`,
        iconUrl: `${this.responseValue.data.current.weather[0]?.icon}.svg`,
      } as CurrentDay;

      if (icon === '09n' ||
          icon === '09d' ||
          icon === '04n' ||
          icon === '10d' ||
          icon === '10n') {
        this.isRainy = true;
      }
    },

    extractNextFiveDays: function (): void {
      if (!this?.responseValue?.data?.daily) return;
      this.weekDaysConfig = this.responseValue.data.daily.splice(0, 6).map((day: any, index: number) => {
        return {
          dayName: index === 0 ? 'Today' : getWeekDay(new Date().getDay() + index),
          highTemp: Math.floor(day?.temp.max),
          lowTemp: Math.floor(day?.temp.min),
          iconUrl: `${day?.weather[0].icon}.svg`,
        } as WeekDay;
      });
    },
  },
})
</script>

<style lang="scss" scoped>
.weather-report-container {
  padding: 30px;
  background-image: linear-gradient(#0668C2, #1C0168);
  border-radius: 20px;
  max-width: 900px;
  min-height: 244px;
  width: 100%;

  @media only screen and (max-width: 550px) {
    padding: 24px;
  }
}

.week-day-report {
  display: flex;
  align-items: flex-end;

  + .week-day-report {
    @media only screen and (max-width: 550px) {
      margin-top: 20px;
    }
  }
}

.week-days-container {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  margin: 27px 0 0;

  @media only screen and (max-width: 550px) {
    margin: 49px 0 0;
    flex-direction: column;
  }
}

.rain-effect {
  position: relative;
}
</style>
